## graphite2 1.3.11

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.0 FATAL_ERROR)
cmake_policy(SET CMP0012 NEW)
include(TestBigEndian)

project(graphite2)
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR})
if (NOT CMAKE_BUILD_TYPE)
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY VALUE Release)
endif (NOT CMAKE_BUILD_TYPE)

option(BUILD_SHARED_LIBS "Make library a shared library instead of static" ON)

enable_language(CXX C)

include_directories(${PROJECT_SOURCE_DIR}/include)

enable_testing()

set(GRAPHITE2_VM_TYPE auto CACHE STRING "Choose the type of vm machine: Auto, Direct or Call.")
option(GRAPHITE2_NSEGCACHE "Compile out the gr_*_with_seg_cache APIs")
option(GRAPHITE2_NFILEFACE "Compile out the gr_make_file_face* APIs")
option(GRAPHITE2_NTRACING "Compile out log segment tracing capability")
option(GRAPHITE2_TELEMETRY "Add memory usage telemetry")
option(GRAPHITE2_ASAN "Enable Address Sanitizing")


message(STATUS "Build: " ${CMAKE_BUILD_TYPE})
string(REPLACE "ON"  "shared"  _LIB_OBJECT_TYPE ${BUILD_SHARED_LIBS})
string(REPLACE "OFF" "static"  _LIB_OBJECT_TYPE ${_LIB_OBJECT_TYPE})
string(REPLACE "ON" "disabled" _SEGCACHE_SUPPORT ${GRAPHITE2_NSEGCACHE})
string(REPLACE "OFF" "enabled" _SEGCACHE_SUPPORT ${_SEGCACHE_SUPPORT})
string(REPLACE "ON" "disabled" _FILEFACE_SUPPORT ${GRAPHITE2_NFILEFACE})
string(REPLACE "OFF" "enabled" _FILEFACE_SUPPORT ${_FILEFACE_SUPPORT})
string(REPLACE "ON" "disabled" _TRACING_SUPPORT ${GRAPHITE2_NTRACING})
string(REPLACE "OFF" "enabled" _TRACING_SUPPORT ${_TRACING_SUPPORT})
message(STATUS "Building library: " ${_LIB_OBJECT_TYPE})
message(STATUS "Segment Cache support: " ${_SEGCACHE_SUPPORT})
message(STATUS "File Face support: " ${_FILEFACE_SUPPORT})
message(STATUS "Tracing support: " ${_TRACING_SUPPORT})

if (GRAPHITE2_ASAN)
    add_definitions(-fsanitize=address -fno-omit-frame-pointer -g)
    find_program(ASAN_SYMBOLIZER llvm-symbolizer
            PATHS "/usr/lib" "/usr/local/lib"
            PATH_SUFFIXES "llvm-3.5/bin" "llvm-3.4/bin" "llvm-3.3/bin")
endif (GRAPHITE2_ASAN)

string(TOLOWER ${GRAPHITE2_VM_TYPE} GRAPHITE2_VM_TYPE)
if (NOT GRAPHITE2_VM_TYPE MATCHES "auto|direct|call")
    message(SEND_ERROR "unrecognised vm machine type: ${GRAPHITE2_VM_TYPE}. Only Auto, Direct or Call are available")
endif (NOT GRAPHITE2_VM_TYPE MATCHES "auto|direct|call")
if (GRAPHITE2_VM_TYPE STREQUAL "auto")
    if (CMAKE_BUILD_TYPE MATCHES "[Rr]el(ease|[Ww]ith[Dd]eb[Ii]nfo)")
        set(GRAPHITE2_VM_TYPE "direct")
    else(CMAKE_BUILD_TYPE MATCHES "[Rr]el(ease|[Ww]ith[Dd]eb[Ii]nfo)")
        set(GRAPHITE2_VM_TYPE "call")
    endif(CMAKE_BUILD_TYPE MATCHES "[Rr]el(ease|[Ww]ith[Dd]eb[Ii]nfo)")
endif (GRAPHITE2_VM_TYPE STREQUAL "auto")
if (GRAPHITE2_VM_TYPE STREQUAL "direct" AND NOT (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang"))
    message(WARNING "vm machine type direct can only be built using GCC")
    set(GRAPHITE2_VM_TYPE "call")
endif (GRAPHITE2_VM_TYPE STREQUAL "direct" AND NOT (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang"))
message(STATUS "Using vm machine type: ${GRAPHITE2_VM_TYPE}")

add_subdirectory(src)
add_subdirectory(tests)
add_subdirectory(doc)
if (NOT (GRAPHITE2_NSEGCACHE OR GRAPHITE2_NFILEFACE))
    add_subdirectory(gr2fonttest)
endif (NOT (GRAPHITE2_NSEGCACHE OR GRAPHITE2_NFILEFACE))

set(version 3.0.1)
set(libdir ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX})
set(includedir ${CMAKE_INSTALL_PREFIX}/include)

configure_file(graphite2.pc.in graphite2.pc)

install(FILES ${PROJECT_BINARY_DIR}/graphite2.pc DESTINATION lib${LIB_SUFFIX}/pkgconfig)

=== doc/CMakeLists.txt ===
project(docs)

set(GRAPHITE2_DOXYGEN_CONFIG public CACHE STRING "Specifies the base configuration file for doxygen. Current values: public, all")

find_program(A2X a2x)
find_program(DBLATEX dblatex)
find_program(DOXYGEN doxygen)
find_program(LATEX pdflatex)

set(DOC_DEPENDS)
if(A2X)
    if(DBLATEX)
        add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/manual.pdf
                           DEPENDS ${PROJECT_SOURCE_DIR}/[a-z]*.txt
                           COMMAND ${A2X} --icons -D ${PROJECT_BINARY_DIR} ${PROJECT_SOURCE_DIR}/manual.txt)
        add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/GTF.pdf
                           DEPENDS ${PROJECT_SOURCE_DIR}/GTF.txt
                           COMMAND ${A2X} --icons -D ${PROJECT_BINARY_DIR} ${PROJECT_SOURCE_DIR}/GTF.txt)
        set(DOC_DEPENDS ${PROJECT_BINARY_DIR}/manual.pdf ${PROJECT_BINARY_DIR}/GTF.pdf)
    endif(DBLATEX)
    add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/manual.html
                       DEPENDS ${PROJECT_SOURCE_DIR}/[a-z]*.txt ${PROJECT_SOURCE_DIR}/graphite.css
                       COMMAND ${A2X} -f xhtml --stylesheet=graphite.css -D ${PROJECT_BINARY_DIR} ${PROJECT_SOURCE_DIR}/manual.txt)
    add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/GTF.html
                       DEPENDS ${PROJECT_SOURCE_DIR}/GTF.txt ${PROJECT_SOURCE_DIR}/graphite.css
                       COMMAND ${A2X} -f xhtml --stylesheet=graphite.css -D ${PROJECT_BINARY_DIR} ${PROJECT_SOURCE_DIR}/GTF.txt)
    set(DOC_DEPENDS ${DOC_DEPENDS} ${PROJECT_BINARY_DIR}/manual.html ${PROJECT_BINARY_DIR}/GTF.html)
endif(A2X)

if(DOXYGEN AND LATEX)
    add_custom_command(OUTPUT ${PROJECT_BINARY_DIR}/doxygen/latex/refman.pdf
                        DEPENDS ${PROJECT_SOURCE_DIR}/../include/graphite2/*.h
                        MAIN_DEPENDENCY ${PROJECT_SOURCE_DIR}/${GRAPHITE2_DOXYGEN_CONFIG}.cfg
                        COMMAND ${DOXYGEN} ${PROJECT_SOURCE_DIR}/${GRAPHITE2_DOXYGEN_CONFIG}.cfg
                        COMMAND make -C ${PROJECT_BINARY_DIR}/doxygen/latex)
    set(DOC_DEPENDS ${DOC_DEPENDS} ${PROJECT_BINARY_DIR}/doxygen/latex/refman.pdf)
endif(DOXYGEN AND LATEX)

add_custom_target(docs DEPENDS ${DOC_DEPENDS})

=== gr2fonttest/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.0 FATAL_ERROR)

project(gr2fonttest)

enable_testing()

if  (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
	add_definitions(-D_SCL_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS -DUNICODE)
endif (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")

add_executable(gr2fonttest gr2FontTest.cpp UtfCodec.cpp)
target_link_libraries(gr2fonttest graphite2)

if (GRAPHITE2_ASAN)
    set_target_properties(gr2fonttest PROPERTIES LINK_FLAGS "-fsanitize=address")
endif (GRAPHITE2_ASAN)

if (BUILD_SHARED_LIBS)
    # copy the DLL so that gr2fonttest can find it
    add_custom_target(${PROJECT_NAME}_copy_dll ALL 
	    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${graphite2_core_BINARY_DIR}/${CMAKE_CFG_INTDIR}/${CMAKE_SHARED_LIBRARY_PREFIX}graphite2${CMAKE_SHARED_LIBRARY_SUFFIX} ${PROJECT_BINARY_DIR}/${CMAKE_CFG_INTDIR})
    add_dependencies(${PROJECT_NAME}_copy_dll graphite2 gr2fonttest)
endif (BUILD_SHARED_LIBS)

install(TARGETS gr2fonttest EXPORT gr2fonttest RUNTIME DESTINATION bin)

=== src/CMakeLists.txt ===
#    GRAPHITE2 LICENSING
#
#    Copyright 2010, SIL International
#    All rights reserved.
#
#    This library is free software; you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published
#    by the Free Software Foundation; either version 2.1 of License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should also have received a copy of the GNU Lesser General Public
#    License along with this library in the file named "LICENSE".
#    If not, write to the Free Software Foundation, 51 Franklin Street, 
#    Suite 500, Boston, MA 02110-1335, USA or visit their web page on the 
#    internet at http://www.fsf.org/licenses/lgpl.html.

CMAKE_MINIMUM_REQUIRED(VERSION 2.8.0 FATAL_ERROR)
project(graphite2_core)
cmake_policy(SET CMP0012 NEW)
INCLUDE(CheckCXXSourceCompiles)

set(GRAPHITE_API_CURRENT 3)
set(GRAPHITE_API_REVISION 0)
set(GRAPHITE_API_AGE 1)
set(GRAPHITE_VERSION ${GRAPHITE_API_CURRENT}.${GRAPHITE_API_REVISION}.${GRAPHITE_API_AGE})
set(GRAPHITE_SO_VERSION ${GRAPHITE_API_CURRENT})

include(TestBigEndian)

include_directories(${PROJECT_SOURCE_DIR})

set(SEGCACHE SegCache.cpp SegCacheEntry.cpp SegCacheStore.cpp)
if (GRAPHITE2_NSEGCACHE)
    add_definitions(-DGRAPHITE2_NSEGCACHE)
    set(SEGCACHE)
endif (GRAPHITE2_NSEGCACHE)

set(FILEFACE FileFace.cpp)
if (GRAPHITE2_NFILEFACE)
    add_definitions(-DGRAPHITE2_NFILEFACE)
    set(FILEFACE)
endif (GRAPHITE2_NFILEFACE)

set(TRACING json.cpp)
if (GRAPHITE2_NTRACING)
    add_definitions(-DGRAPHITE2_NTRACING)
    set(TRACING)
endif (GRAPHITE2_NTRACING)

if (GRAPHITE2_TELEMETRY)
    add_definitions(-DGRAPHITE2_TELEMETRY)
endif (GRAPHITE2_TELEMETRY)

if (NOT BUILD_SHARED_LIBS)
    add_definitions(-DGRAPHITE2_STATIC)
endif (NOT BUILD_SHARED_LIBS)

set(GRAPHITE_HEADERS 
    ../include/graphite2/Font.h
    ../include/graphite2/Segment.h
    ../include/graphite2/Types.h
    ../include/graphite2/Log.h
    )

file(GLOB PRIVATE_HEADERS inc/*.h) 

add_library(graphite2
    ${GRAPHITE2_VM_TYPE}_machine.cpp
    gr_char_info.cpp
    gr_features.cpp
    gr_face.cpp
    gr_font.cpp
    gr_logging.cpp
    gr_segment.cpp
    gr_slot.cpp
    CachedFace.cpp
    CmapCache.cpp
    Code.cpp
    Collider.cpp
    Decompressor.cpp
    Face.cpp
    FeatureMap.cpp
    Font.cpp
    GlyphFace.cpp
    GlyphCache.cpp
    Intervals.cpp
    Justifier.cpp
    NameTable.cpp
    Pass.cpp
    Position.cpp
    Segment.cpp
    Silf.cpp
    Slot.cpp
    Sparse.cpp
    TtfUtil.cpp
    UtfCodec.cpp
    ${FILEFACE}
    ${SEGCACHE}
    ${TRACING})

set_target_properties(graphite2 PROPERTIES  PUBLIC_HEADER "${GRAPHITE_HEADERS}"
                                            SOVERSION ${GRAPHITE_SO_VERSION}
                                            VERSION ${GRAPHITE_VERSION}
                                            LT_VERSION_CURRENT ${GRAPHITE_API_CURRENT}
                                            LT_VERSION_REVISION ${GRAPHITE_API_REVISION}
                                            LT_VERSION_AGE ${GRAPHITE_API_AGE})

if  (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    set_target_properties(graphite2 PROPERTIES
        COMPILE_FLAGS   "-Wall -Wextra -Wno-unknown-pragmas -Wendif-labels -Wshadow -Wctor-dtor-privacy -Wnon-virtual-dtor -fno-rtti -fno-exceptions -fvisibility=hidden -fvisibility-inlines-hidden"
        LINK_FLAGS      "-nodefaultlibs ${GRAPHITE_LINK_FLAGS}"
        LINKER_LANGUAGE C)
    if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "x86|i.86")
        add_definitions(-mfpmath=sse -msse2)
    endif (${CMAKE_SYSTEM_PROCESSOR} MATCHES "x86|i.86")
    if (CMAKE_COMPILER_IS_GNUCXX)
        add_definitions(-Wdouble-promotion)
    endif (CMAKE_COMPILER_IS_GNUCXX)
    message(STATUS "Compiler ID is: ${CMAKE_CXX_COMPILER_ID}")
    if (${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
        add_definitions(-Wimplicit-fallthrough)
    endif (${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang")
    if (${CMAKE_CXX_COMPILER} MATCHES  ".*mingw.*")
        target_link_libraries(graphite2 kernel32 msvcr90 mingw32 gcc user32)
    else (${CMAKE_CXX_COMPILER} MATCHES  ".*mingw.*")
        if (GRAPHITE2_ASAN)
            target_link_libraries(graphite2 c gcc_s)
        else (GRAPHITE2_ASAN)
            target_link_libraries(graphite2 c gcc)
        endif (GRAPHITE2_ASAN)
        include(Graphite)
        if (BUILD_SHARED_LIBS)
            nolib_test(stdc++ $<TARGET_SONAME_FILE:graphite2>)
        endif (BUILD_SHARED_LIBS)
    endif (${CMAKE_CXX_COMPILER} MATCHES  ".*mingw.*")
    set(CMAKE_CXX_IMPLICIT_LINK_LIBRARIES "")
    CREATE_LIBTOOL_FILE(graphite2 "/lib${LIB_SUFFIX}")
endif (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")

if  (${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")
    set_target_properties(graphite2 PROPERTIES
        COMPILE_FLAGS   "-Wall -Wextra -Wno-unknown-pragmas -Wimplicit-fallthrough -Wendif-labels -Wshadow -Wno-ctor-dtor-privacy -Wno-non-virtual-dtor -fno-rtti -fno-exceptions -fvisibility=hidden -fvisibility-inlines-hidden -mfpmath=sse -msse2"
        LINK_FLAGS      "-nodefaultlibs"
        LINKER_LANGUAGE C)
    target_link_libraries(graphite2 c)
    include(Graphite)
    nolib_test(stdc++ $<TARGET_SONAME_FILE:graphite2>)
    set(CMAKE_CXX_IMPLICIT_LINK_LIBRARIES "")
    CREATE_LIBTOOL_FILE(graphite2 "/lib${LIB_SUFFIX}")
endif (${CMAKE_SYSTEM_NAME} STREQUAL "Darwin")

if  (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    set_target_properties(graphite2 PROPERTIES 
        COMPILE_DEFINITIONS "_SCL_SECURE_NO_WARNINGS;_CRT_SECURE_NO_WARNINGS;UNICODE;GRAPHITE2_EXPORTING")
endif (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")


install(TARGETS graphite2 EXPORT graphite2 LIBRARY DESTINATION lib${LIB_SUFFIX} ARCHIVE DESTINATION lib${LIB_SUFFIX} PUBLIC_HEADER DESTINATION include/graphite2 RUNTIME DESTINATION bin)
install(EXPORT graphite2 DESTINATION share/graphite2 NAMESPACE gr2_)

=== tests/CMakeLists.txt ===
project(testing)
include(Graphite)
include(CMakeDependentOption)
CMAKE_DEPENDENT_OPTION(GRAPHITE2_COMPARE_RENDERER "Build tool to compare output of different renderers" OFF
                        "NOT GRAPHITE2_NFILEFACE;NOT GRAPHITE2_NSEGCACHE" OFF)

include_directories(${graphite2_core_SOURCE_DIR})
set(S ${graphite2_core_SOURCE_DIR})

add_library(graphite2-base STATIC
    ${S}/FeatureMap.cpp
    ${S}/Intervals.cpp
    ${S}/NameTable.cpp
    ${S}/Sparse.cpp
    ${S}/TtfUtil.cpp
    ${S}/UtfCodec.cpp)

add_library(graphite2-segcache STATIC
    ${S}/call_machine.cpp
    ${S}/Code.cpp
    ${S}/Collider.cpp
    ${S}/CmapCache.cpp
    ${S}/Decompressor.cpp
    ${S}/Face.cpp
    ${S}/FileFace.cpp
    ${S}/GlyphCache.cpp
    ${S}/GlyphFace.cpp
    ${S}/gr_logging.cpp
    ${S}/Pass.cpp
    ${S}/SegCache.cpp
    ${S}/SegCacheEntry.cpp
    ${S}/Segment.cpp
    ${S}/Silf.cpp
    ${S}/Slot.cpp
    )

set(TELEMETRY)
if (GRAPHITE2_TELEMETRY)
    set(TELEMETRY ";GRAPHITE2_TELEMETRY")
endif (GRAPHITE2_TELEMETRY)

if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    set_target_properties(graphite2-base PROPERTIES
                            COMPILE_DEFINITIONS "GRAPHITE2_STATIC;GRAPHITE2_NTRACING;_SCL_SECURE_NO_WARNINGS;_CRT_SECURE_NO_WARNINGS;UNICODE")
    set_target_properties(graphite2-segcache PROPERTIES
                            COMPILE_DEFINITIONS "GRAPHITE2_STATIC;GRAPHITE2_NTRACING${TELEMETRY};_SCL_SECURE_NO_WARNINGS;_CRT_SECURE_NO_WARNINGS;UNICODE")
else (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
# don't -D GRAPHITE2_STATIC so that tests can see the API symbols in the static library
    set_target_properties(graphite2-base PROPERTIES
        COMPILE_FLAGS       "-Wall -Wextra -fno-rtti -fno-exceptions"
        COMPILE_DEFINITIONS "GRAPHITE2_NTRACING"
        LINK_FLAGS          "-nodefaultlibs ${GRAPHITE_LINK_FLAGS}"
        LINKER_LANGUAGE     C)
    set_target_properties(graphite2-segcache PROPERTIES
        COMPILE_FLAGS       "-Wall -Wextra -fno-rtti -fno-exceptions"
        COMPILE_DEFINITIONS "GRAPHITE2_NTRACING${TELEMETRY}"
        LINK_FLAGS          "-nodefaultlibs ${GRAPHITE_LINK_FLAGS}"
        LINKER_LANGUAGE     C)
endif (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")

if (GRAPHITE2_COMPARE_RENDERER)
    add_subdirectory(comparerenderer)
endif (GRAPHITE2_COMPARE_RENDERER)
add_subdirectory(endian)
add_subdirectory(bittwiddling)
if (NOT GRAPHITE2_NFILEFACE)
    add_subdirectory(examples)
endif (NOT GRAPHITE2_NFILEFACE)
add_subdirectory(featuremap)
add_subdirectory(grlist)
add_subdirectory(json)
add_subdirectory(nametabletest)
if (NOT (GRAPHITE2_NSEGCACHE OR GRAPHITE2_NFILEFACE))
    add_subdirectory(segcache)
endif (NOT (GRAPHITE2_NSEGCACHE OR GRAPHITE2_NFILEFACE))
add_subdirectory(sparsetest)
add_subdirectory(utftest)
if (NOT GRAPHITE2_NFILEFACE)
    add_subdirectory(vm)
endif (NOT GRAPHITE2_NFILEFACE)
add_subdirectory(fuzz-tests)

enable_testing()

fonttest(padauk1 Padauk.ttf 1015 102F 100F 1039 100F 1031 1038)
fonttest(padauk2 Padauk.ttf 1000 103C 102D 102F)
fonttest(padauk3 Padauk.ttf 101e 1004 103a 1039 1001 103b 102d 102f 1004 103a 1038)
fonttest(padauk4 Padauk.ttf 1005 1000 1039 1000 1030)
fonttest(padauk5 Padauk.ttf 1000 103c 1031 102c 1004 1037 103a)
fonttest(padauk6 Padauk.ttf 1000 102D 1005 1039 1006 102C)
# padauk7 can cause an infinite loop, though the text is miss-spelt
fonttest(padauk7 Padauk.ttf 1017 1014 103c 103d 102f)
fonttest(padauk8 Padauk.ttf 1004 103A 1039 1005)
fonttest(padauk9 Padauk.ttf 1004 103A 1039)
fonttest(padauk10 Padauk.ttf 1004 103D 1000 103A -feat kdot=1,wtri=1)
fonttest(padauk11 Padauk.ttf 100B 1039 100C 1031 102C)
fonttest(padauk12 Padauk.ttf 0048 0065 006C 006C 006F 0020 004D 0075 006D -j 107)
fonttest(scher1 Scheherazadegr.ttf 0628 0628 064E 0644 064E 0654 0627 064E -rtl)
fonttest(scher2 Scheherazadegr.ttf 0627 0644 0625 0639 0644 0627 0646 -rtl)
fonttest(scher3 Scheherazadegr.ttf 0627 0031 0032 002D 0034 0035 0627 -rtl)
fonttest(scher4 Scheherazadegr.ttf 0627 0653 06AF -rtl)
fonttest(scher5 Scheherazadegr_noglyfs.ttf 0627 0653 06AF -rtl)
fonttest(charis1 charis_r_gr.ttf 0069 02E6 02E8 02E5)
fonttest(charis2 charis_r_gr.ttf 1D510 0041 1D513)
fonttest(charis3 charis_r_gr.ttf 0054 0069 1ec3 0075 -feat lang=vie)
fonttest(charis4 charis_r_gr.ttf 006b 0361 070)
fonttest(charis5 charis_r_gr.ttf 0020 006C 0325 0065)
fonttest(charis6 charis_r_gr.ttf 0048 0065 006C 006C 006F 0020 004D 0075 006D -j 107)
fonttest(charis7 charis_fast.ttf 0049 0065 006C 006C 006F)
fonttest(charis8 charis_r_gr.ttf 0054 0069 1ec3 0075 -feat "lang=vi  ")
fonttest(magyar1 MagyarLinLibertineG.ttf 0031 0035 -feat 210=36)
fonttest(magyar2 MagyarLinLibertineG.ttf 0031 0030 -feat 210=200)
fonttest(magyar3 MagyarLinLibertineG.ttf 0066 0069 0066 0074 0079 002d 0066 0069 0076 0065 -feat 209=3)
fonttest(grtest1 grtest1gr.ttf 0062 0061 0061 0061 0061 0061 0061 0062 0061)
fonttest(general1 general.ttf 0E01 0062)
fonttest(piglatin1 PigLatinBenchmark_v3.ttf 0068 0065 006C 006C 006F)

feattest(padauk_feat Padauk.ttf)
feattest(charis_feat charis_r_gr.ttf)
feattest(scher_feat Scheherazadegr.ttf)

if (BUILD_SHARED_LIBS)
    cmptest(padaukcmp1 Padauk.ttf my_HeadwordSyllables.txt)
    cmptest(chariscmp1 charis_r_gr.ttf udhr_eng.txt)
    cmptest(chariscmp2 charis_r_gr.ttf udhr_yor.txt)
    cmptest(annacmp1 Annapurnarc2.ttf udhr_nep.txt)
    cmptest(schercmp1 Scheherazadegr.ttf udhr_arb.txt -r)
    cmptest(awamicmp1 Awami_test.ttf awami_tests.txt -r -e 1)
    cmptest(awamicmp2 Awami_compressed_test.ttf awami_tests.txt -r -e 1)
endif (BUILD_SHARED_LIBS)

=== tests/bittwiddling/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.0 FATAL_ERROR)
project(bits)
include(Graphite)
include_directories(${graphite2_core_SOURCE_DIR})

if  (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    add_definitions(-D_SCL_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS -DUNICODE)
    add_custom_target(${PROJECT_NAME}_copy_dll ALL
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${graphite2_core_BINARY_DIR}/${CMAKE_CFG_INTDIR}/${CMAKE_SHARED_LIBRARY_PREFIX}graphite2${CMAKE_SHARED_LIBRARY_SUFFIX} ${PROJECT_BINARY_DIR}/${CMAKE_CFG_INTDIR})
    add_dependencies(${PROJECT_NAME}_copy_dll graphite2 bits)
endif (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")


add_executable(bits bits.cpp)
target_link_libraries(bits graphite2-base)

add_test(NAME bits COMMAND $<TARGET_FILE:bits>)
if (GRAPHITE2_ASAN)
    set_target_properties(bits PROPERTIES LINK_FLAGS "-fsanitize=address")
    set_property(TEST bits APPEND PROPERTY ENVIRONMENT "ASAN_SYMBOLIZER_PATH=${ASAN_SYMBOLIZER}")
endif (GRAPHITE2_ASAN)

=== tests/comparerenderer/CMakeLists.txt ===
project(comparerenderer)

if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    set(RT_LDFLAGS "rt")
endif (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")

include_directories(../common ${PROJECT_SOURCE_DIR}/../../src)

file(GLOB PRIVATE_HEADERS *.h) 
set_source_files_properties(${PRIVATE_HEADERS} PROPERTIES HEADER_FILE_ONLY true)

add_executable(comparerenderer
    CompareRenderer.cpp
    ${PRIVATE_HEADERS})

if  (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    set_target_properties(comparerenderer PROPERTIES
    COMPILE_FLAGS   "-std=c++11")
endif (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")

if (GRAPHITE2_ASAN)
    set_target_properties(comparerenderer PROPERTIES LINK_FLAGS "-fsanitize=address")
endif (GRAPHITE2_ASAN)

# rt is for timing
target_link_libraries(comparerenderer graphite2-base graphite2 ${FREETYPE_LIBRARIES} ${GLIB_LD_FLAGS} ${HB_LDFLAGS} ${HB1_LDFLAGS} ${GR_LDFLAGS} ${ICU_LDFLAGS} ${RT_LDFLAGS})

if  (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    add_definitions(-D_CRT_SECURE_NO_WARNINGS -D_SCL_SECURE_NO_WARNINGS)
    add_custom_target(${PROJECT_NAME}_copy_dll ALL
    COMMAND ${CMAKE_COMMAND} -E copy_if_different ${graphite2_core_BINARY_DIR}/${CMAKE_CFG_INTDIR}/${CMAKE_SHARED_LIBRARY_PREFIX}graphite2${CMAKE_SHARED_LIBRARY_SUFFIX} ${PROJECT_BINARY_DIR}/${CMAKE_CFG_INTDIR})
    add_dependencies(${PROJECT_NAME}_copy_dll graphite2 iconv comparerenderer)
endif  (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")

macro(comparetest TESTNAME FONTFILE TEXTFILE)
    if (${GR_FOUND})
    # comparision tests between old and new graphite
        add_test(NAME ${TESTNAME}_comparison COMMAND $<TARGET_FILE:comparerenderer>
        -t ${testing_SOURCE_DIR}/texts/${TEXTFILE} -f ${testing_SOURCE_DIR}/fonts/${FONTFILE} -s 12 -v -l ${PROJECT_BINARY_DIR}/${TESTNAME}.log -n --tolerance 0.0001 ${ARGN})
        if (GRAPHITE2_ASAN)
            set_property(TEST ${TESTNAME}_comparison APPEND PROPERTY ENVIRONMENT "ASAN_SYMBOLIZER_PATH=${ASAN_SYMBOLIZER}")
        endif (GRAPHITE2_ASAN)
        set_tests_properties(${TESTNAME}_comparison PROPERTIES TIMEOUT 3)
        add_test(NAME ${TESTNAME}cmpOutput COMMAND ${CMAKE_COMMAND} -E compare_files ${PROJECT_BINARY_DIR}/${TESTNAME}.log ${PROJECT_SOURCE_DIR}/../standards/${TESTNAME}${PLATFORM_TEST_SUFFIX}.log)
        set_tests_properties(${TESTNAME}cmpOutput PROPERTIES DEPENDS ${TESTNAME})
    endif (${GR_FOUND})
endmacro(comparetest)

comparetest(charis charis_r_gr.ttf udhr_eng.txt)
comparetest(padauk Padauk.ttf my_HeadwordSyllables.txt)
comparetest(padauk_ulon Padauk.ttf my_HeadwordSyllables.txt --features ulon=1)
comparetest(charis_yor charis_r_gr.ttf udhr_yor.txt)
comparetest(piglatin PigLatinBenchmark_v3.ttf udhr_eng.txt)
# silgraphite and gr2 bidi algorithms don't quite agree enough
# comparetest(scheherazade_arb Scheherazadegr.ttf udhr_arb.txt --rtl)
comparetest(annapurna_nep Annapurnarc2.ttf udhr_nep.txt)

# comparerenderer can also be used for font testing
# install(TARGETS comparerenderer EXPORT comparerenderer RUNTIME DESTINATION bin)

=== tests/endian/CMakeLists.txt ===
project(endian)

include_directories(${graphite2_core_SOURCE_DIR})

add_executable(endiantest endiantest.cpp)
if (GRAPHITE2_ASAN)
    set_target_properties(endiantest PROPERTIES LINK_FLAGS "-fsanitize=address")
endif (GRAPHITE2_ASAN)

add_test(NAME endian COMMAND $<TARGET_FILE:endiantest> 10)
if (GRAPHITE2_ASAN)
    set_property(TEST endian APPEND PROPERTY ENVIRONMENT "ASAN_SYMBOLIZER_PATH=${ASAN_SYMBOLIZER}")
endif (GRAPHITE2_ASAN)

=== tests/featuremap/CMakeLists.txt ===
project(featuremaptest)
include(Graphite)
include_directories(${graphite2_core_SOURCE_DIR})

if  (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    add_definitions(-D_SCL_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS -DUNICODE)
    add_custom_target(${PROJECT_NAME}_copy_dll ALL
        COMMAND ${CMAKE_COMMAND} -E copy_if_different ${graphite2_core_BINARY_DIR}/${CMAKE_CFG_INTDIR}/${CMAKE_SHARED_LIBRARY_PREFIX}graphite2${CMAKE_SHARED_LIBRARY_SUFFIX} ${PROJECT_BINARY_DIR}/${CMAKE_CFG_INTDIR})
    add_dependencies(${PROJECT_NAME}_copy_dll graphite2 featuremaptest)
endif (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")

set(S ${graphite2_core_SOURCE_DIR})
add_executable(featuremaptest featuremaptest.cpp)
if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
#    set_target_properties(featuremaptest PROPERTIES COMPILE_DEFINITIONS "GRAPHITE2_STATIC")
endif (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")

if (GRAPHITE2_ASAN)
    set_target_properties(featuremaptest PROPERTIES LINK_FLAGS "-fsanitize=address")
endif (GRAPHITE2_ASAN)
target_link_libraries(featuremaptest graphite2 graphite2-base graphite2-segcache graphite2-base)

add_test(NAME featuremaptest COMMAND $<TARGET_FILE:featuremaptest> ${testing_SOURCE_DIR}/fonts/tiny.ttf)
set_tests_properties(featuremaptest PROPERTIES TIMEOUT 3)
if (GRAPHITE2_ASAN)
    set_property(TEST featuremaptest APPEND PROPERTY ENVIRONMENT "ASAN_SYMBOLIZER_PATH=${ASAN_SYMBOLIZER}")
endif (GRAPHITE2_ASAN)

=== tests/fuzz-tests/CMakeLists.txt ===
project(fuzztesting)

function(trimtail VAR RESULT)
    STRING(REGEX MATCH "[^/]+$" trimtail_result ${${VAR}})
    set(${RESULT} ${trimtail_result} PARENT_SCOPE)
    STRING(REGEX REPLACE "^(.*)/[^/]+$" "\\1" trimtail_remainder ${${VAR}})
    set(${VAR} ${trimtail_remainder} PARENT_SCOPE)
endfunction(trimtail)

function(hasr VAR RESULT)
    STRING(REGEX MATCH "-r(\\.|$)" hasr_result ${${VAR}})
    if (hasr_result)
        set(${RESULT} "-r" PARENT_SCOPE)
    else (hasr_result)
        set(${RESULT} "" PARENT_SCOPE)
    endif (hasr_result)
endfunction(hasr)

add_custom_target(fuzztest)
file(GLOB_RECURSE tfiles RELATIVE ${PROJECT_SOURCE_DIR} *.fuzz)
set(lastfontname "")
if (NOT GRAPHITE2_ASAN)
    set(noasan -t 20 --memory=8000 --valgrind)
endif (NOT GRAPHITE2_ASAN)
foreach (tfile IN LISTS tfiles)
    set(tpath ${tfile})
    trimtail(tpath tname)
    trimtail(tpath textname)
    trimtail(tpath fname)
    hasr(tname dirargs)
    if (NOT lastfontname EQUAL fname)
        add_custom_command(TARGET fuzztest PRE_BUILD COMMAND echo ${fname})
        set(lastfontname ${fname})
    endif(NOT lastfontname EQUAL fname)
    add_custom_command(TARGET fuzztest PRE_BUILD COMMAND ${PROJECT_SOURCE_DIR}/../fuzztest ARGS -l fuzzregress-${fname}-${textname}-${tname}.log -f ${PROJECT_SOURCE_DIR}/../fonts/${fname}.ttf -q ${noasan} --include=required,graphite --exclude==fontdir,opentype,volt,advtypo,post -V -k --input=${PROJECT_SOURCE_DIR}/${fname}/${textname}/${tname} -- ../comparerenderer/comparerenderer -q ${dirargs} -s 12 -n -f {} -t ${PROJECT_SOURCE_DIR}/../texts/${textname}.txt)
    add_custom_command(TARGET fuzztest POST_BUILD COMMAND test -s fuzzregress-${fname}-${textname}-${tname}.log && echo test: ${fname} ${textname} ${tname} failed. || true)
    add_custom_command(TARGET fuzztest PRE_BUILD COMMAND ${PROJECT_SOURCE_DIR}/../fuzztest ARGS -l fuzzregress-demand-${fname}-${textname}-${tname}.log -f ${PROJECT_SOURCE_DIR}/../fonts/${fname}.ttf -q ${noasan} --include=required,graphite --exclude==fontdir,opentype,volt,advtypo,post -V -k --input=${PROJECT_SOURCE_DIR}/${fname}/${textname}/${tname} -- ../comparerenderer/comparerenderer --demand -q ${dirargs} -s 12 -n -f {} -t ${PROJECT_SOURCE_DIR}/../texts/${textname}.txt)
    add_custom_command(TARGET fuzztest POST_BUILD COMMAND test -s fuzzregress-demand-${fname}-${textname}-${tname}.log && echo demand test: ${fname} ${textname} ${tname} failed. || true)
endforeach(tfile)

=== tests/grlist/CMakeLists.txt ===
project(grlisttest)

include_directories(${graphite2_core_SOURCE_DIR})

set(S ${graphite2_core_SOURCE_DIR})

add_executable(grlisttest grlisttest.cpp)
#add_executable(intervalsettest intervalsettest.cpp)

if (GRAPHITE2_ASAN)
    set_target_properties(grlisttest PROPERTIES LINK_FLAGS "-fsanitize=address")
#    set_target_properties(intervalsettest PROPERTIES LINK_FLAGS "-fsanitize=address")
endif (GRAPHITE2_ASAN)

#target_link_libraries(intervalsettest graphite2 graphite2-base)
add_test(NAME grlist COMMAND $<TARGET_FILE:grlisttest>)
#add_test(NAME intervalset COMMAND $<TARGET_FILE:intervalsettest>)
if (GRAPHITE2_ASAN)
    set_property(TEST grlist APPEND PROPERTY ENVIRONMENT "ASAN_SYMBOLIZER_PATH=${ASAN_SYMBOLIZER}")
#    set_property(TEST intervalset APPEND PROPERTY ENVIRONMENT "ASAN_SYMBOLIZER_PATH=${ASAN_SYMBOLIZER}")
endif (GRAPHITE2_ASAN)

=== tests/nametabletest/CMakeLists.txt ===
project(nametabletest)
include_directories(${graphite2_core_SOURCE_DIR})

add_executable(nametabletest nametabletest.cpp)
target_link_libraries(nametabletest graphite2-base)

add_test(NAME nametabletest COMMAND $<TARGET_FILE:nametabletest>)
set_tests_properties(nametabletest PROPERTIES TIMEOUT 3)
if (GRAPHITE2_ASAN)
    set_target_properties(nametabletest PROPERTIES LINK_FLAGS "-fsanitize=address")
    set_property(TEST nametabletest APPEND PROPERTY ENVIRONMENT "ASAN_SYMBOLIZER_PATH=${ASAN_SYMBOLIZER}")
endif (GRAPHITE2_ASAN)

=== debian/changelog ===
graphite2 (1.3.11-2) unstable; urgency=medium

  * backport upstream commit db132b4731a9b4c9534144ba3a18e65b390e9ff6
    to fix CVE-2018-7999 (closes: #892590)

 -- Rene Engelhard <rene@debian.org>  Sun, 11 Mar 2018 13:22:48 +0100

graphite2 (1.3.11-1) unstable; urgency=medium

  * New upstream version 1.3.11

  * update Vcs-* to salsa

  * backport proper PYTHON_EXECUTABLE support commits from upstream and remove
    our own python3-testsuite.diff

 -- Rene Engelhard <rene@debian.org>  Sat, 10 Mar 2018 14:15:13 +0100

graphite2 (1.3.10-8) unstable; urgency=medium

  * oops, forgot to remove (temporarily added) Files-Excluded: again...

 -- Rene Engelhard <rene@debian.org>  Fri, 08 Dec 2017 00:06:36 +0100

graphite2 (1.3.10-7) unstable; urgency=medium

  * create a libgraphite2-utils package containing gr2fonttest
    (closes: 680243).
  * mention LGPL-2.1+ or MPL-1.1 or GPL-2+ in copyright (except some file
    which are LGPL-2.1+ only)
  * add UDHR stuff (public-domain)

 -- Rene Engelhard <rene@debian.org>  Thu, 07 Dec 2017 17:36:50 +0100

graphite2 (1.3.10-6) unstable; urgency=medium

  * fix Build-Depends:, since we use python3 now we need to B-D: on python3, 
  * Build-Depend just on python3-fonttools

 -- Rene Engelhard <rene@debian.org>  Sun, 15 Oct 2017 16:24:48 +0000

graphite2 (1.3.10-5) unstable; urgency=medium

  * Team upload.
  * Fix the tests so they can run with python3.
  * Enable the fnttxtreader tests again.
  * d/control: avoid duplicated "Section" field.
  * d/copyright:
    + fix syntax to match the final copyright-format 1.0.
    + update, the project is now mostly LGPL-2.1+.
    + add myself to the copyright holders for debian/*.
    + add a bunch of missing license texts.
  * override lintian warning embedded-javascript-library, false positive due
    to doxygen.
  * d/rules: drop duplicated override_dh_strip.

 -- Mattia Rizzolo <mattia@debian.org>  Thu, 28 Sep 2017 18:53:41 +0200

graphite2 (1.3.10-4) unstable; urgency=medium

  * remove obsolete/long not used perl and mono parts from rules/control
  * temporarily disable fnttxtrender-tests since fonttools lost it's python2
    module and it doesn't work with python3 (yet)

 -- Rene Engelhard <rene@debian.org>  Tue, 19 Sep 2017 21:21:00 +0000

graphite2 (1.3.10-3) unstable; urgency=medium

  [ Mattia Rizzolo ]
  * d/control: Add Vcs-* fields.
  * d/control: Mark libgraphite2-dev Multi-Arch:same (Closes: #875647)
  * d/control: Mark libgraphite2-doc as Multi-Arch:foreign (Closes: #875648)
  * d/control: Bump Standards-Version to 4.1.0

 -- Rene Engelhard <rene@debian.org>  Tue, 19 Sep 2017 21:10:07 +0200

graphite2 (1.3.10-2) unstable; urgency=medium

  * s/latex-xcolor/texlive-latex-recommended/ in Build-Depends-Indep
    (closes: #865254)

 -- Rene Engelhard <rene@debian.org>  Tue, 20 Jun 2017 07:15:10 +0200

=== debian/control ===
Source: graphite2
Priority: optional
Section: libs
Maintainer: Debian LibreOffice Maintainers <debian-openoffice@lists.debian.org>
Uploaders: Rene Engelhard <rene@debian.org>, Daniel Glassey <wdg@debian.org>
Build-Depends: debhelper (>= 9.20151219), dh-exec (>= 0.3), dpkg-dev (>= 1.18.2~), cmake, python3, python3-fonttools
Build-Depends-Indep: asciidoc-dblatex, doxygen, docbook-xsl, texlive-latex-recommended, libxml2-utils, graphviz
Standards-Version: 4.1.0
Homepage: http://graphite.sil.org/
Vcs-Git: https://salsa.debian.org/libreoffice-team/graphite2.git
Vcs-Browser: https://salsa.debian.org/libreoffice-team/graphite2

Package: libgraphite2-3
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: libgraphite2-2.0.0
Replaces: libgraphite2-2.0.0
Breaks: libgraphite2-2.0.0 (<< 1.2.0)
Multi-Arch: same
Description: Font rendering engine for Complex Scripts -- library
 Graphite is a system that can be used to create and use "smart fonts" capable
 of displaying writing systems with various complex behaviors, such as:
 contextual shaping, ligatures, reordering, split glyphs, bidirectionality,
 stacking diacritics and complex positioning.
 .  
 This library was designed and developed by the NRSI (Non-Roman Script
 Initiative) within SIL International (www.sil.org) to act as a complement to
 other smart font rendering technologies with limited practical local
 extensibility. Its purpose is to help meet the needs of a very large number
 of "minority language" communities for local extensibility of complex script
 behaviors. 
 .
 The behavior of the rendering engine for a given writing system is specified
 through extra tables added to a TrueType font.  These tables are generated by
 compiling a GDL (Graphite Description Language) source file into a font using
 grcompiler. 
 .
 This package contains the shared library.

Package: libgraphite2-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libgraphite2-3 (= ${binary:Version}), ${misc:Depends}
Suggests: libgraphite2-utils
Description: Development files for libgraphite2
 Graphite is a system that can be used to create and use "smart fonts" capable
 of displaying writing systems with various complex behaviors, such as:
 contextual shaping, ligatures, reordering, split glyphs, bidirectionality,
 stacking diacritics and complex positioning.
 .
 This library was designed and developed by the NRSI (Non-Roman Script
 Initiative) within SIL International (www.sil.org) to act as a complement to
 other smart font rendering technologies with limited practical local
 extensibility. Its purpose is to help meet the needs of a very large number
 of "minority language" communities for local extensibility of complex script
 behaviors. 
 .
 The behavior of the rendering engine for a given writing system is specified
 through extra tables added to a TrueType font.  These tables are generated by
 compiling a GDL (Graphite Description Language) source file into a font using
 grcompiler. 
 .
 This package contains the development libraries for libgraphite2 

Package: libgraphite2-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Documentation for libgraphite2
 Graphite is a system that can be used to create and use "smart fonts" capable
 of displaying writing systems with various complex behaviors, such as:
 contextual shaping, ligatures, reordering, split glyphs, bidirectionality,
 stacking diacritics and complex positioning.
 .
 This library was designed and developed by the NRSI (Non-Roman Script
 Initiative) within SIL International (www.sil.org) to act as a complement to
 other smart font rendering technologies with limited practical local
 extensibility. Its purpose is to help meet the needs of a very large number
 of "minority language" communities for local extensibility of complex script
 behaviors. 
 .
 The behavior of the rendering engine for a given writing system is specified
 through extra tables added to a TrueType font.  These tables are generated by
 compiling a GDL (Graphite Description Language) source file into a font using
 grcompiler. 
 .
 PDF and HTML documentation for libgraphite2

Package: libgraphite2-utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Section: fonts
Description: Font rendering engine for Complex Scripts -- utilities
 Graphite is a system that can be used to create and use "smart fonts" capable
 of displaying writing systems with various complex behaviors, such as:
 contextual shaping, ligatures, reordering, split glyphs, bidirectionality,
 stacking diacritics and complex positioning.
 .
 This package contains gr2fonttest.

=== debian/rules ===
#!/usr/bin/make -f

export DPKG_EXPORT_BUILDFLAGS = 0
include /usr/share/dpkg/architecture.mk

%:
	dh $@ --builddirectory=build

override_dh_auto_build-arch:
	dh_auto_build --parallel

override_dh_auto_build-indep:
	echo "Building docs"
	dh_auto_build -- docs

override_dh_auto_install:
	if [ -f ./build/src/libgraphite2.so.3 ]; then \
		dh_auto_install; \
	else \
		dh_install -plibgraphite2-doc --sourcedir=$(CURDIR); \
	fi

override_dh_auto_test:
	if [ -f ./build/src/libgraphite2.so.3 ]; then \
		dh_auto_test; \
	fi

override_dh_auto_clean:
	-find . -name "CTestCostData.txt" | xargs rm
	-find . -name "LastTest.log"  | xargs rm
	rm -f tests/graphite.pyc
	rm -rf tests/__pycache__
	dh_auto_clean

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE:STRING=Release -DGRAPHITE2_NTRACING:BOOL=ON -DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH) -DPYTHON_EXECUTABLE=$(shell which python3)
	find . -type f ! -name "rules" ! -name "changelog" \
		-exec sed -i -e 's/\-O3//g' {} \;

override_dh_strip:
	dh_strip --ddeb-migration="libgraphite2-3-dbg (<= 1.3.4-1)"

=== debian/watch ===
version=2
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/<project>-$1\.tar\.gz/ \
  https://github.com/silnrsi/graphite/tags .*/v?(\d\S*)\.tar\.gz
